clear all
clc

[aaa dir_name ext]=fileparts(cd);
dir_name = [dir_name ext];
name = dir_name;

% trenovacie prikazy
command = ['./trenuj_matus_e_parlament_sp_init.pl align_peto proto' ' ' name ' ' 'phone_peto.lis'];
dlmwrite('trenuj_init.bat', command, 'delimiter', '')

% trenovacie prikazy pre rozdelene inicializacne trenovanie na 4 procaky

command = ['./trenuj_matus_e_parlament_sp_init_1.pl align_peto proto' ' ' name ' ' 'phone_peto.lis_1'];
dlmwrite('trenuj_init_1.bat', command, 'delimiter', '')

command = ['./trenuj_matus_e_parlament_sp_init_2.pl align_peto proto' ' ' name ' ' 'phone_peto.lis_2'];
dlmwrite('trenuj_init_2.bat', command, 'delimiter', '')

command = ['./trenuj_matus_e_parlament_sp_init_3.pl align_peto proto' ' ' name ' ' 'phone_peto.lis_3'];
dlmwrite('trenuj_init_3.bat', command, 'delimiter', '')

command = ['./trenuj_matus_e_parlament_sp_init_4.pl align_peto proto' ' ' name ' ' 'phone_peto.lis_4'];
dlmwrite('trenuj_init_4.bat', command, 'delimiter', '')

%%%

command = ['./trenuj_matus_e_parlament_sp_herest.pl align_peto proto' ' ' name ' ' 'phone_peto.lis'];
dlmwrite('trenuj_herest.bat', command, 'delimiter', '')

command = ['./trenuj_matus_e_parlament_sp.pl align_peto proto' ' ' name ' ' 'phone_peto.lis'];
dlmwrite('trenuj.bat', command, 'delimiter', '')


% testovacie prikazy - vsetky verzie
a = ['*'];
b = [''''];
mixture = 256;
i = 1;
while mixture >= 1
    num_mix = mixture;
    model_name = num2str(num_mix);
    command = ['HVite -C trirecHDmfccSav16kHz.cfg -H' ' ' 'workdir1/model_align_peto' name '.' model_name '_2.mmf' ' ' '-S testlist_par.scp -l' ' ' b a b ' ' '-i mfforiginal.' model_name '.mlf -t 400.0 -u 3072 -v 200.0 -s 12.0 -p -8.0 -T 1 -w testwdnetPeto1 slovnik_peto3.dic config/phone_peto.lis'];
    comm{i} = command;
    mixture = mixture/2;
    i = i + 1;
end
%%%
for j = numel(comm): -1 : 1
    dlmwrite('recognition.bat', comm{j}, 'delimiter', '', '-append')
end
%%%
for j = numel(comm): -1 : 5
    dlmwrite('recognition1-16.bat', comm{j}, 'delimiter', '', '-append')
end
for j = numel(comm)-5: -1 : 1
    dlmwrite('recognition32-256.bat', comm{j}, 'delimiter', '', '-append')
end
%%%
for j = numel(comm): -1 : 7
    dlmwrite('recognition1-4.bat', comm{j}, 'delimiter', '', '-append')
end
for j = numel(comm)-3: -1 : 4
    dlmwrite('recognition8-32.bat', comm{j}, 'delimiter', '', '-append')
end
for j = numel(comm)-6: -1 : 1
    dlmwrite('recognition64-256.bat', comm{j}, 'delimiter', '', '-append')
end
%%%
vec_mixture = {'256' '128' '64' '32' '16' '8' '4' '2' '1'};
for j = numel(comm): -1 : 1
    dlmwrite(['recognition' vec_mixture{j} '.bat'], comm{j}, 'delimiter', '')
%     dlmwrite('recognition.bat', ['./recognition' vec_mixture{j} '.bat'], '-append', 'delimiter', '')
end
fileattrib('*.bat', '+x');
exit
