#! /usr/bin/env perl
#
# train.perl mastermlf proto modelcomment modelfile
# code is country code: SK SL ...
# Train script for BN news speech detection based on HTK


my $modelsfilename;

if ($ARGV[3] eq "") {$modelsfilename="models.txt";} else {$modelsfilename=$ARGV[3];}


    my $dir;
goto skip;
    $dir = "features_train";

    my(@newfns) = ();
    opendir(BIN, $dir) or die "Can't open directory $dir: $!";
    while( defined ($file = readdir BIN) )
           {         # print $file;
           @newfns = ($file, @newfns)  if -B "$dir/$file";
           }
    closedir(BIN);
    
open(FILE,"> trainlist.lst") || die "Could not open trainlist: $!\n";
foreach $name (@newfns)
{


print FILE $dir . "\/$name\n" if ($name !~ m/^\./i);


} 
close(FILE);
#skip: #ak mame trainlist
open(FILE,"config/$modelsfilename") || die "Could not open config/$modelsfilename: $!\n";
    my @modelsfile = <FILE>;
    close(FILE);
open(FILE,"> logs/train_$ARGV[0].log") || die "Could not open logs/train_$ARGV[0].log: $!\n";
print FILE "";
close(FILE);
 print "test\n";
my $model;
foreach $model (@modelsfile)
{
 chop($model);
if ($model ne "")
{print "HInit $model\n";
print "HInit -i 100 -C config/reest.cfg -S trainlist.lst -I $ARGV[0].mlf -T 3 -l $model -M workdir1 -o $model config/$ARGV[1].hmm\n";
local($cmd) = "HInit -i 100 -C config/reest.cfg -S trainlist.lst -I $ARGV[0].mlf -T 3 -l $model -M workdir1 -o $model config/$ARGV[1].hmm >> logs/train_$ARGV[0].log";
    die "DOS command failed:\n $cmd\n $!\n" if system "$cmd";
print "HRest $model\n";
local($cmd) = "HRest -i 100 -C config/reest.cfg -S trainlist.lst -I $ARGV[0].mlf -T 3 -l $model -M workdir1 workdir1/$model >> logs/train_$ARGV[0].log";
    die "DOS command failed:\n $cmd\n $!\n" if system "$cmd";
}
}
skip: #preskocime trenovanie inicializacnych modelov
open(FILE,"config/$modelsfilename") || die "Could not open $fn: $!\n";
    my @modelsfile = <FILE>;
    close(FILE);

open(FILE2,"> workdir1/model_$ARGV[0]$ARGV[2].1.mmf") || die "Could not open workdir1/model_$ARGV[0]$ARGV[2].mix1.mmf: $!\n";

foreach $model (@modelsfile)
{ chop($model);
if ($model ne "")
{
open(FILE,"workdir1/$model") || die "Could not open workdir1/$model: $!\n";
    @lines = <FILE>;
    close(FILE);

    print FILE2 @lines;
}
}
    close(FILE2);
local($cmd) = "./AddTeeModel workdir1/model_$ARGV[0]$ARGV[2].1.mmf > workdir1/model_$ARGV[0]$ARGV[2].1tee.mmf";
 die "DOS command failed:\n $cmd\n $!\n" if system "$cmd";

print " ...tying silence and tee models to workdir1/model_$ARGV[0]$ARGV[2].1.mmf\n";
open(FILE,"> workdir1/sil.hed") || die "Could not open workdir1/sil.hed: $!\n";
    
  print FILE  "AT 2 4 0.2 {sil.transP}\n";
print FILE "AT 4 2 0.2 {sil.transP}\n";
print FILE  "AT 1 3 0.3 {sp.transP}\n";
print FILE  "TI silst {sil.state[3],sp.state[2]}\n";
close(FILE);

local($cmd) = "HHEd -H workdir1/model_$ARGV[0]$ARGV[2].1tee.mmf  -w workdir1/model_$ARGV[0]$ARGV[2].1_0.mmf workdir1/sil.hed config/$modelsfilename";
die "DOS command failed:\n $cmd\n $!\n" if system "$cmd";

print "HERest tee model workdir1/model_$ARGV[0]$ARGV[2].1.mmf\n";
#local($cmd) = "HERest -C config/reest.cfg -S trainlist.lst -I $ARGV[0].mlf -T 3 -M workdir1 -H workdir1/model_$ARGV[0]$ARGV[2].1.mmf config/$modelsfilename >> logs/train_$ARGV[0].log";
local($cmd) = "./reestimate.pl  workdir1/model_$ARGV[0]$ARGV[2].1_0.mmf  workdir1/model_$ARGV[0]$ARGV[2].1_1.mmf config/reest.cfg trainlist.lst $ARGV[0].mlf lab config/$modelsfilename logs/train_$ARGV[0].log";
    die "DOS command failed:\n $cmd\n $!\n" if system "$cmd";
#local($cmd) = "HERest -C config/reest.cfg -S trainlist.lst -I $ARGV[0].mlf -T 3 -M workdir1 -H workdir1/model_$ARGV[0]$ARGV[2].1.mmf config/$modelsfilename >> logs/train_$ARGV[0].log";
local($cmd) = "./reestimate.pl  workdir1/model_$ARGV[0]$ARGV[2].1_1.mmf  workdir1/model_$ARGV[0]$ARGV[2].1_2.mmf config/reest.cfg trainlist.lst $ARGV[0].mlf lab config/$modelsfilename logs/train_$ARGV[0].log";
    die "DOS command failed:\n $cmd\n $!\n" if system "$cmd";
    
#skip:
my $num;
my $numhalf; #pocet mixture!

for($num=1;$num<257;$num=$num*2)
{ $numhalf=$num/2;
$cmd = "HHEd -H workdir1/model_$ARGV[0]$ARGV[2].$numhalf\_2.mmf -w workdir1/model_$ARGV[0]$ARGV[2].$num\_0.mmf config/mix$num.hed config/$modelsfilename" if $num>1;
    if ($num>1) {die "command failed:\n $cmd\n $!\n" if system "$cmd";}


print "HERest model_$ARGV[0]$ARGV[2].$num.mmf\n"; 
#local($cmd) = "HERest -C config/reest.cfg -S trainlist.lst -I $ARGV[0].mlf -T 3 -M workdir1 -H workdir1/model_$ARGV[0]$ARGV[2].$num.mmf config/$modelsfilename >> logs/train_$ARGV[0].log";
local($cmd) = "./reestimate.pl  workdir1/model_$ARGV[0]$ARGV[2].$num\_0.mmf  workdir1/model_$ARGV[0]$ARGV[2].$num\_1.mmf config/reest.cfg trainlist.lst $ARGV[0].mlf lab config/$modelsfilename logs/train_$ARGV[0].log";
    die "DOS command failed:\n $cmd\n $!\n" if system "$cmd";
#local($cmd) = "HERest -C config/reest.cfg -S trainlist.lst -I $ARGV[0].mlf -T 3 -M workdir1 -H workdir1/model_$ARGV[0]$ARGV[2].$num.mmf config/$modelsfilename >> logs/train_$ARGV[0].log";
local($cmd) = "./reestimate.pl  workdir1/model_$ARGV[0]$ARGV[2].$num\_1.mmf  workdir1/model_$ARGV[0]$ARGV[2].$num\_2.mmf config/reest.cfg trainlist.lst $ARGV[0].mlf lab config/$modelsfilename logs/train_$ARGV[0].log";
    die "DOS command failed:\n $cmd\n $!\n" if system "$cmd";

}

#open(FILE,"> logs/train_$ARGV[0].log") || die "Could not open $fn: $!\n";
#print FILE "";
#close(FILE);

