clear all
clc
format short

[aaa dir_name ext]=fileparts(cd);
dir_name = [dir_name ext];
model_name = dir_name;
results_tab = zeros(9,3);

for i = 1:9
    results_tab(i,1) = 2^(i-1);
end

for i = 0:8
    char_i = num2str(2^i);
    file_name = ['vysledok' char_i];
    fid = fopen(file_name);
    file_vysledok = textscan(fid, '%s');
    fclose(fid);
    j=1;
    while file_vysledok{1}{j} ~= '#'
            j = j + 1;
    end
    results_tab(i+1,2) = 100*str2num(file_vysledok{1}{j+2});
    results_tab(i+1,3) = 100*str2num(file_vysledok{1}{j+4});
end

name=['results_' model_name];

dlmwrite(name, model_name, '-append', 'delimiter', '');
dlmwrite(name, ' ', '-append', 'delimiter', '');
dlmwrite(name, results_tab, '-append', 'delimiter', '\t', 'precision', 4);
dlmwrite(name, ' ', '-append', 'delimiter', '');
dlmwrite(name, ' ', '-append', 'delimiter', '');
exit
